#ifndef STRING_H
#define STRING_H

#include "types.h"

// Function prototypes for string operations
size_t strlen(const char *str);           // Calculate the length of a string
int strcmp(const char *str1, const char *str2);  // Compare two strings
int strncmp(const char *s1, const char *s2, size_t n); //offset comparison
char *strcpy(char *dest, const char *src);  // Copy one string to another
char *strcat(char *dest, const char *src);  // Concatenate two strings
void itoa(int num, char *str, int base);   // Convert integer to string (itoa)
int atoi(const char *str);
void reverse(char *str, size_t length);    // Reverse a string
void *memset(void *ptr, int value, size_t num);
#endif // STRING_H
