#ifndef UTILS_H
#define UTILS_H

#include "types.h"
#define LOG_BUFFER_SIZE 4096  // Size of the log buffer (4 KB)

// Utility functions
void log_message(const char *msg);          // Log a message to the screen
int abs_value(int num);                     // Get the absolute value of an integer
unsigned int power(unsigned int base, unsigned int exp);  // Calculate power: base^exp
void swap(int *a, int *b);                  // Swap two integers
void delay(int count);                      // Simple delay function
void itoa(int num, char *str, int base);    // Convert an integer to a string
void itoa_hex(int num, char *str);          // Convert an integer to hexadecimal string
unsigned int hex_to_int(const char *hex_str);
int eval_expression(const char *expr);
int ffs_custom(uint64_t x);
int max(int x, int y);
int min(int x, int y);
#endif // UTILS_H
